/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Thomas Fahrni
   co-programmer:
*/
#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_AI
#include "ai_team.h"
#include "swarm_gorel.h"
#include "swarm_module.h"
#include "debug.h"

void AITeam::process(float dt)
{
	std::map<int,SwarmModule*>::iterator it;
	for (it= swarms.begin(); it!= swarms.end(); it++ ){
	
		if(it->second->taskDone()){
			std::cout << "Task Done!\n";
			changeSwarmModule(it, new SwarmGoRel);
		
			if(enemyList->size()>0){
				it->second->setEnemyList(enemyList);
				it->second->orderRelObject(enemyList->at(0));
				it->second->orderRelPos(Vector(60,0,0));
				it->second->orderSpeed(50);
				it->second->orderView(Vector(0,0,1));
				it->second->orderMaxTime(5);
			}
		}
		it->second->process(dt);
	}
}

void AITeam::changeSwarmModule(std::map<int,SwarmModule*>::iterator it,SwarmModule* newAI)
{
			SwarmModule* oldAI = it->second;
			newAI->getAttributesFrom(oldAI);
			it->second=newAI;
			delete oldAI;
}


void AITeam::addAI(int swarmNumber, WorldEntity* npc)
{
	std::pair<std::map<int,SwarmModule*>::iterator,bool> p;
	SwarmModule* newSwarm=new SwarmGoRel();
	p=swarms.insert(std::make_pair(swarmNumber,newSwarm));
	if(!p.second)delete newSwarm;
	p.first->second->addAI(npc);
}


void AITeam::removeAI(int swarmNumber, WorldEntity* npc)
{
	std::map<int,SwarmModule*>::iterator it = swarms.find(swarmNumber);
	if(it==swarms.end())return;
	it->second->removeAI(npc);
	if(it->second->getSwarmSize()==0){
		delete it->second;
		swarms.erase(it);
	}
}
